diff --git a/testing/mozharness/external_tools/mouse_and_screen_resolution.py b/testing/mozharness/external_tools/mouse_and_screen_resolution.py
index 29e46e1bc0..63835e8bc4 100755
--- a/testing/mozharness/external_tools/mouse_and_screen_resolution.py
+++ b/testing/mozharness/external_tools/mouse_and_screen_resolution.py
@@ -9,6 +9,7 @@
 # Author(s):     Zambrano Gasparnian, Armen <armenzg@mozilla.com>
 # Target:        Python 2.5 or newer
 #
+from __future__ import print_function
 from optparse import OptionParser
 from ctypes import windll, Structure, c_ulong, byref
 try:
@@ -17,7 +18,7 @@ except:
     import simplejson as json
 import os
 import sys
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 import socket
 import platform
 import time
@@ -28,15 +29,15 @@ default_mouse_position = {"x": 1010, "y": 10}
 def wfetch(url, retries=5):
     while True:
         try:
-            return urllib2.urlopen(url, timeout=30).read()
-        except urllib2.HTTPError, e:
-            print("Failed to fetch '%s': %s" % (url, str(e)))
-        except urllib2.URLError, e:
-            print("Failed to fetch '%s': %s" % (url, str(e)))
-        except socket.timeout, e:
-            print("Time out accessing %s: %s" % (url, str(e)))
-        except socket.error, e:
-            print("Socket error when accessing %s: %s" % (url, str(e)))
+            return six.moves.urllib.request.urlopen(url, timeout=30).read()
+        except six.moves.urllib.error.HTTPError as e:
+            print(("Failed to fetch '%s': %s" % (url, str(e))))
+        except six.moves.urllib.error.URLError as e:
+            print(("Failed to fetch '%s': %s" % (url, str(e))))
+        except socket.timeout as e:
+            print(("Time out accessing %s: %s" % (url, str(e))))
+        except socket.error as e:
+            print(("Socket error when accessing %s: %s" % (url, str(e))))
         if retries < 0:
             raise Exception("Could not fetch url '%s'" % url)
         retries -= 1
@@ -47,7 +48,7 @@ def main():
 
     if not (platform.version().startswith('6.1.760') and not 'PROGRAMFILES(X86)' in os.environ):
         # We only want to run this for Windows 7 32-bit
-        print "INFO: This script was written to be used with Windows 7 32-bit machines."
+        print("INFO: This script was written to be used with Windows 7 32-bit machines.")
         return 0
 
     parser = OptionParser()
@@ -61,7 +62,7 @@ def main():
 
     if (options.configuration_url == None and
         options.configuration_file == None):
-        print "You must specify --configuration-url or --configuration-file."
+        print("You must specify --configuration-url or --configuration-file.")
         return 1
 
     if options.configuration_file:
@@ -74,42 +75,42 @@ def main():
             conf_dict = json.loads(wfetch(options.configuration_url))
             new_screen_resolution = conf_dict["win7"]["screen_resolution"]
             new_mouse_position = conf_dict["win7"]["mouse_position"]
-        except urllib2.HTTPError, e:
-            print "This branch does not seem to have the configuration file %s" % str(e)
-            print "Let's fail over to 1024x768."
+        except six.moves.urllib.error.HTTPError as e:
+            print("This branch does not seem to have the configuration file %s" % str(e))
+            print("Let's fail over to 1024x768.")
             new_screen_resolution = default_screen_resolution
             new_mouse_position = default_mouse_position
-        except urllib2.URLError, e:
-            print "INFRA-ERROR: We couldn't reach hg.mozilla.org: %s" % str(e)
+        except six.moves.urllib.error.URLError as e:
+            print("INFRA-ERROR: We couldn't reach hg.mozilla.org: %s" % str(e))
             return 1
-        except Exception, e:
-            print "ERROR: We were not expecting any more exceptions: %s" % str(e)
+        except Exception as e:
+            print("ERROR: We were not expecting any more exceptions: %s" % str(e))
             return 1
 
     current_screen_resolution = queryScreenResolution()
-    print "Screen resolution (current): (%(x)s, %(y)s)" % (current_screen_resolution)
+    print("Screen resolution (current): (%(x)s, %(y)s)" % (current_screen_resolution))
 
     if current_screen_resolution == new_screen_resolution:
-        print "No need to change the screen resolution."
+        print("No need to change the screen resolution.")
     else:
-        print "Changing the screen resolution..."
+        print("Changing the screen resolution...")
         try:
             changeScreenResolution(new_screen_resolution["x"], new_screen_resolution["y"])
-        except Exception, e:
-            print "INFRA-ERROR: We have attempted to change the screen resolution but " + \
-                  "something went wrong: %s" % str(e)
+        except Exception as e:
+            print("INFRA-ERROR: We have attempted to change the screen resolution but " + \
+                  "something went wrong: %s" % str(e))
             return 1
         time.sleep(3)  # just in case
         current_screen_resolution = queryScreenResolution()
-        print "Screen resolution (new): (%(x)s, %(y)s)" % current_screen_resolution
+        print("Screen resolution (new): (%(x)s, %(y)s)" % current_screen_resolution)
 
-    print "Mouse position (current): (%(x)s, %(y)s)" % (queryMousePosition())
+    print("Mouse position (current): (%(x)s, %(y)s)" % (queryMousePosition()))
     setCursorPos(new_mouse_position["x"], new_mouse_position["y"])
     current_mouse_position = queryMousePosition()
-    print "Mouse position (new): (%(x)s, %(y)s)" % (current_mouse_position)
+    print("Mouse position (new): (%(x)s, %(y)s)" % (current_mouse_position))
 
     if current_screen_resolution != new_screen_resolution or current_mouse_position != new_mouse_position:
-        print "INFRA-ERROR: The new screen resolution or mouse positions are not what we expected"
+        print("INFRA-ERROR: The new screen resolution or mouse positions are not what we expected")
         return 1
     else:
         return 0
diff --git a/testing/mozharness/external_tools/robustcheckout.py b/testing/mozharness/external_tools/robustcheckout.py
index e801724c18..dc19ebcdb0 100644
--- a/testing/mozharness/external_tools/robustcheckout.py
+++ b/testing/mozharness/external_tools/robustcheckout.py
@@ -9,7 +9,6 @@ from a source repo using best practices to ensure optimal clone
 times and storage efficiency.
 """
 
-from __future__ import absolute_import
 
 import contextlib
 import errno
@@ -20,7 +19,7 @@ import re
 import socket
 import ssl
 import time
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 
 from mercurial.i18n import _
 from mercurial.node import hex
@@ -314,7 +313,7 @@ def _docheckout(ui, url, dest, upstream, revision, branch, purge, sharebase,
             ui.warn('ssl error: %s\n' % e)
             handlenetworkfailure()
             return True
-        elif isinstance(e, urllib2.URLError):
+        elif isinstance(e, six.moves.urllib.error.URLError):
             if isinstance(e.reason, socket.error):
                 ui.warn('socket error: %s\n' % e.reason)
                 handlenetworkfailure()
@@ -342,7 +341,7 @@ def _docheckout(ui, url, dest, upstream, revision, branch, purge, sharebase,
         try:
             res = hg.clone(ui, {}, cloneurl, dest=dest, update=False,
                            shareopts={'pool': sharebase, 'mode': 'identity'})
-        except (error.Abort, ssl.SSLError, urllib2.URLError) as e:
+        except (error.Abort, ssl.SSLError, six.moves.urllib.error.URLError) as e:
             if handlepullerror(e):
                 return callself()
             raise
@@ -401,7 +400,7 @@ def _docheckout(ui, url, dest, upstream, revision, branch, purge, sharebase,
                 pullop = exchange.pull(repo, remote, heads=pullrevs)
                 if not pullop.rheads:
                     raise error.Abort('unable to pull requested revision')
-        except (error.Abort, ssl.SSLError, urllib2.URLError) as e:
+        except (error.Abort, ssl.SSLError, six.moves.urllib.error.URLError) as e:
             if handlepullerror(e):
                 return callself()
             raise
diff --git a/testing/mozharness/external_tools/virtualenv/setup.py b/testing/mozharness/external_tools/virtualenv/setup.py
index ee03bc5313..9d738d6b62 100644
--- a/testing/mozharness/external_tools/virtualenv/setup.py
+++ b/testing/mozharness/external_tools/virtualenv/setup.py
@@ -1,3 +1,4 @@
+from __future__ import print_function
 import os
 import re
 import shutil
diff --git a/testing/mozharness/external_tools/virtualenv/site.py b/testing/mozharness/external_tools/virtualenv/site.py
index 4e426cdb66..5f7c992285 100644
--- a/testing/mozharness/external_tools/virtualenv/site.py
+++ b/testing/mozharness/external_tools/virtualenv/site.py
@@ -63,11 +63,12 @@ ImportError exception, it is silently ignored.
 
 """
 
+from __future__ import print_function
 import sys
 import os
 
 try:
-    import __builtin__ as builtins
+    import builtins as builtins
 except ImportError:
     import builtins
 try:
@@ -454,7 +455,7 @@ class _Printer(object):
         while 1:
             try:
                 for i in range(lineno, lineno + self.MAXLINES):
-                    print(self.__lines[i])
+                    print((self.__lines[i]))
             except IndexError:
                 break
             else:
@@ -462,9 +463,9 @@ class _Printer(object):
                 key = None
                 while key is None:
                     try:
-                        key = raw_input(prompt)
-                    except NameError:
                         key = input(prompt)
+                    except NameError:
+                        key = eval(input(prompt))
                     if key not in ('', 'q'):
                         key = None
                 if key == 'q':
@@ -723,16 +724,16 @@ def _script():
     if not args:
         print("sys.path = [")
         for dir in sys.path:
-            print("    %r," % (dir,))
+            print(("    %r," % (dir,)))
         print("]")
         def exists(path):
             if os.path.isdir(path):
                 return "exists"
             else:
                 return "doesn't exist"
-        print("USER_BASE: %r (%s)" % (USER_BASE, exists(USER_BASE)))
-        print("USER_SITE: %r (%s)" % (USER_SITE, exists(USER_BASE)))
-        print("ENABLE_USER_SITE: %r" %  ENABLE_USER_SITE)
+        print(("USER_BASE: %r (%s)" % (USER_BASE, exists(USER_BASE))))
+        print(("USER_SITE: %r (%s)" % (USER_SITE, exists(USER_BASE))))
+        print(("ENABLE_USER_SITE: %r" %  ENABLE_USER_SITE))
         sys.exit(0)
 
     buffer = []
@@ -742,7 +743,7 @@ def _script():
         buffer.append(USER_SITE)
 
     if buffer:
-        print(os.pathsep.join(buffer))
+        print((os.pathsep.join(buffer)))
         if ENABLE_USER_SITE:
             sys.exit(0)
         elif ENABLE_USER_SITE is False:
@@ -753,7 +754,7 @@ def _script():
             sys.exit(3)
     else:
         import textwrap
-        print(textwrap.dedent(help % (sys.argv[0], os.pathsep)))
+        print((textwrap.dedent(help % (sys.argv[0], os.pathsep))))
         sys.exit(10)
 
 if __name__ == '__main__':
diff --git a/testing/mozharness/external_tools/virtualenv/virtualenv.py b/testing/mozharness/external_tools/virtualenv/virtualenv.py
index e363021cc1..a46fccaf69 100755
--- a/testing/mozharness/external_tools/virtualenv/virtualenv.py
+++ b/testing/mozharness/external_tools/virtualenv/virtualenv.py
@@ -1,8 +1,10 @@
 #!/usr/bin/env python
 """Create a "virtual" Python installation"""
 
+from __future__ import print_function
 import os
 import sys
+import six
 
 # If we are running in a new interpreter to create a virtualenv,
 # we do NOT want paths from our existing location interfering with anything,
@@ -32,7 +34,7 @@ from distutils.util import strtobool
 from os.path import join
 
 try:
-    import ConfigParser
+    import six.moves.configparser
 except ImportError:
     import configparser as ConfigParser
 
@@ -40,14 +42,14 @@ __version__ = "15.0.1"
 virtualenv_version = __version__  # legacy
 
 if sys.version_info < (2, 6):
-    print('ERROR: %s' % sys.exc_info()[1])
+    print(('ERROR: %s' % sys.exc_info()[1]))
     print('ERROR: this script requires Python 2.6 or greater.')
     sys.exit(101)
 
 try:
-    basestring
+    str
 except NameError:
-    basestring = str
+    str = str
 
 py_version = 'python%s.%s' % (sys.version_info[0], sys.version_info[1])
 
@@ -82,7 +84,7 @@ else:
     try:
         import winreg
     except ImportError:
-        import _winreg as winreg
+        import six.moves.winreg as winreg
 
     def get_installed_pythons():
         try:
@@ -427,7 +429,7 @@ class ConfigOptionParser(optparse.OptionParser):
     configuration files and environmental variables
     """
     def __init__(self, *args, **kwargs):
-        self.config = ConfigParser.RawConfigParser()
+        self.config = six.moves.configparser.RawConfigParser()
         self.files = self.get_config_files()
         self.config.read(self.files)
         optparse.OptionParser.__init__(self, *args, **kwargs)
@@ -473,7 +475,7 @@ class ConfigOptionParser(optparse.OptionParser):
                     val = option.convert_value(key, val)
                 except optparse.OptionValueError:
                     e = sys.exc_info()[1]
-                    print("An error occurred during configuration: %s" % e)
+                    print(("An error occurred during configuration: %s" % e))
                     sys.exit(3)
                 defaults[option.dest] = val
         return defaults
@@ -506,7 +508,7 @@ class ConfigOptionParser(optparse.OptionParser):
         defaults = self.update_defaults(self.defaults.copy())  # ours
         for option in self._get_all_options():
             default = defaults.get(option.dest)
-            if isinstance(default, basestring):
+            if isinstance(default, str):
                 opt_str = option.get_opt_string()
                 defaults[option.dest] = option.check_value(opt_str, default)
         return optparse.Values(defaults)
@@ -673,8 +675,8 @@ def main():
         parser.print_help()
         sys.exit(2)
     if len(args) > 1:
-        print('There must be only one argument: DEST_DIR (you gave %s)' % (
-            ' '.join(args)))
+        print(('There must be only one argument: DEST_DIR (you gave %s)' % (
+            ' '.join(args))))
         parser.print_help()
         sys.exit(2)
 
@@ -840,8 +842,8 @@ def install_wheel(project_names, py_executable, search_dirs=None,
     # PIP_FIND_LINKS uses space as the path separator and thus cannot have paths
     # with spaces in them. Convert any of those to local file:// URL form.
     try:
-        from urlparse import urljoin
-        from urllib import pathname2url
+        from urllib.parse import urljoin
+        from urllib.request import pathname2url
     except ImportError:
         from urllib.parse import urljoin
         from urllib.request import pathname2url
@@ -968,12 +970,12 @@ def path_locations(home_dir):
             size = max(len(home_dir)+1, 256)
             buf = ctypes.create_unicode_buffer(size)
             try:
-                u = unicode
+                u = str
             except NameError:
                 u = str
             ret = GetShortPathName(u(home_dir), buf, size)
             if not ret:
-                print('Error: the path "%s" has a space in it' % home_dir)
+                print(('Error: the path "%s" has a space in it' % home_dir))
                 print('We could not determine the short pathname for it.')
                 print('Exiting.')
                 sys.exit(3)
@@ -1520,7 +1522,7 @@ def fix_lib64(lib_dir, symlink=True):
         return
     # Check we have a lib64 library path
     if not [p for p in distutils.sysconfig.get_config_vars().values()
-            if isinstance(p, basestring) and 'lib64' in p]:
+            if isinstance(p, str) and 'lib64' in p]:
         return
 
     logger.debug('This system uses lib64; symlinking lib64 to lib')
diff --git a/testing/mozharness/external_tools/virtualenv/virtualenv_embedded/distutils-init.py b/testing/mozharness/external_tools/virtualenv/virtualenv_embedded/distutils-init.py
index 29fc1da459..fe392b712b 100644
--- a/testing/mozharness/external_tools/virtualenv/virtualenv_embedded/distutils-init.py
+++ b/testing/mozharness/external_tools/virtualenv/virtualenv_embedded/distutils-init.py
@@ -25,9 +25,9 @@ else:
 from distutils import dist, sysconfig
 
 try:
-    basestring
+    str
 except NameError:
-    basestring = str
+    str = str
 
 ## patch build_ext (distutils doesn't know how to get the libs directory
 ## path on windows - it hardcodes the paths around the patched sys.prefix)
@@ -38,7 +38,7 @@ if sys.platform == 'win32':
         def finalize_options (self):
             if self.library_dirs is None:
                 self.library_dirs = []
-            elif isinstance(self.library_dirs, basestring):
+            elif isinstance(self.library_dirs, str):
                 self.library_dirs = self.library_dirs.split(os.pathsep)
             
             self.library_dirs.insert(0, os.path.join(sys.real_prefix, "Libs"))
diff --git a/testing/mozharness/external_tools/virtualenv/virtualenv_embedded/site.py b/testing/mozharness/external_tools/virtualenv/virtualenv_embedded/site.py
index 7969769c36..2b14669adb 100644
--- a/testing/mozharness/external_tools/virtualenv/virtualenv_embedded/site.py
+++ b/testing/mozharness/external_tools/virtualenv/virtualenv_embedded/site.py
@@ -63,10 +63,11 @@ ImportError exception, it is silently ignored.
 
 """
 
+from __future__ import print_function
 import sys
 import os
 try:
-    import __builtin__ as builtins
+    import builtins as builtins
 except ImportError:
     import builtins
 try:
@@ -453,7 +454,7 @@ class _Printer(object):
         while 1:
             try:
                 for i in range(lineno, lineno + self.MAXLINES):
-                    print(self.__lines[i])
+                    print((self.__lines[i]))
             except IndexError:
                 break
             else:
@@ -461,9 +462,9 @@ class _Printer(object):
                 key = None
                 while key is None:
                     try:
-                        key = raw_input(prompt)
-                    except NameError:
                         key = input(prompt)
+                    except NameError:
+                        key = eval(input(prompt))
                     if key not in ('', 'q'):
                         key = None
                 if key == 'q':
@@ -721,16 +722,16 @@ def _script():
     if not args:
         print("sys.path = [")
         for dir in sys.path:
-            print("    %r," % (dir,))
+            print(("    %r," % (dir,)))
         print("]")
         def exists(path):
             if os.path.isdir(path):
                 return "exists"
             else:
                 return "doesn't exist"
-        print("USER_BASE: %r (%s)" % (USER_BASE, exists(USER_BASE)))
-        print("USER_SITE: %r (%s)" % (USER_SITE, exists(USER_BASE)))
-        print("ENABLE_USER_SITE: %r" %  ENABLE_USER_SITE)
+        print(("USER_BASE: %r (%s)" % (USER_BASE, exists(USER_BASE))))
+        print(("USER_SITE: %r (%s)" % (USER_SITE, exists(USER_BASE))))
+        print(("ENABLE_USER_SITE: %r" %  ENABLE_USER_SITE))
         sys.exit(0)
 
     buffer = []
@@ -740,7 +741,7 @@ def _script():
         buffer.append(USER_SITE)
 
     if buffer:
-        print(os.pathsep.join(buffer))
+        print((os.pathsep.join(buffer)))
         if ENABLE_USER_SITE:
             sys.exit(0)
         elif ENABLE_USER_SITE is False:
@@ -751,7 +752,7 @@ def _script():
             sys.exit(3)
     else:
         import textwrap
-        print(textwrap.dedent(help % (sys.argv[0], os.pathsep)))
+        print((textwrap.dedent(help % (sys.argv[0], os.pathsep))))
         sys.exit(10)
 
 if __name__ == '__main__':
diff --git a/testing/mozharness/mach_commands.py b/testing/mozharness/mach_commands.py
index f453397db7..87e9304bd7 100644
--- a/testing/mozharness/mach_commands.py
+++ b/testing/mozharness/mach_commands.py
@@ -9,8 +9,9 @@ import os
 import re
 import subprocess
 import sys
-import urllib
-import urlparse
+import urllib.request
+import urllib.parse
+import urllib.error
 
 import mozinfo
 
@@ -137,7 +138,7 @@ class MozharnessRunner(MozbuildObject):
 
 
     def path_to_url(self, path):
-        return urlparse.urljoin('file:', urllib.pathname2url(path))
+        return urllib.parse.urljoin('file:', urllib.request.pathname2url(path))
 
     def _installer_url(self):
         package_re = {
diff --git a/testing/mozharness/mozfile/__init__.py b/testing/mozharness/mozfile/__init__.py
index 37b8babb80..b276d461df 100644
--- a/testing/mozharness/mozfile/__init__.py
+++ b/testing/mozharness/mozfile/__init__.py
@@ -2,4 +2,4 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from mozfile import *
+from .mozfile import *
diff --git a/testing/mozharness/mozfile/mozfile.py b/testing/mozharness/mozfile/mozfile.py
index ac0edcab4f..132262a72f 100644
--- a/testing/mozharness/mozfile/mozfile.py
+++ b/testing/mozharness/mozfile/mozfile.py
@@ -4,14 +4,15 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 from contextlib import contextmanager
 import os
 import shutil
 import stat
 import tarfile
 import tempfile
-import urlparse
-import urllib2
+import six.moves.urllib.parse
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 import zipfile
 import time
 
@@ -54,8 +55,8 @@ def extract_zip(src, dest):
     else:
         try:
             bundle = zipfile.ZipFile(src)
-        except Exception, e:
-            print "src: %s" % src
+        except Exception as e:
+            print("src: %s" % src)
             raise
 
     namelist = bundle.namelist()
@@ -161,7 +162,7 @@ def remove(path):
                     raise
                 retry_count += 1
 
-                print 'Retrying to remove "%s" because it is in use.' % path
+                print('Retrying to remove "%s" because it is in use.' % path)
                 time.sleep(retry_delay)
 
     if not os.path.exists(path):
@@ -347,7 +348,7 @@ def is_url(thing):
     Return True if thing looks like a URL.
     """
 
-    parsed = urlparse.urlparse(thing)
+    parsed = six.moves.urllib.parse.urlparse(thing)
     if 'scheme' in parsed:
         return len(parsed.scheme) >= 2
     else:
@@ -366,7 +367,7 @@ def load(resource):
 
     if not is_url(resource):
         # if no scheme is given, it is a file path
-        return file(resource)
+        return open(resource)
 
-    return urllib2.urlopen(resource)
+    return six.moves.urllib.request.urlopen(resource)
 
diff --git a/testing/mozharness/mozharness/base/config.py b/testing/mozharness/mozharness/base/config.py
index 9c17b33818..3af26cdba2 100644
--- a/testing/mozharness/mozharness/base/config.py
+++ b/testing/mozharness/mozharness/base/config.py
@@ -24,11 +24,12 @@ TODO:
   these settings are set.
 """
 
+from __future__ import print_function
 from copy import deepcopy
 from optparse import OptionParser, Option, OptionGroup
 import os
 import sys
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 import socket
 import time
 try:
@@ -156,7 +157,7 @@ def parse_config_file(file_name, quiet=False, search_path=None,
     if file_name.endswith('.py'):
         global_dict = {}
         local_dict = {}
-        execfile(file_path, global_dict, local_dict)
+        exec(compile(open(file_path, "rb").read(), file_path, 'exec'), global_dict, local_dict)
         config = local_dict[config_dict_name]
     elif file_name.endswith('.json'):
         fh = open(file_path)
@@ -177,18 +178,18 @@ def download_config_file(url, file_name):
     max_sleeptime = 5 * 60
     while True:
         if n >= attempts:
-            print "Failed to download from url %s after %d attempts, quiting..." % (url, attempts)
+            print("Failed to download from url %s after %d attempts, quiting..." % (url, attempts))
             raise SystemError(-1)
         try:
-            contents = urllib2.urlopen(url, timeout=30).read()
+            contents = six.moves.urllib.request.urlopen(url, timeout=30).read()
             break
-        except urllib2.URLError, e:
-            print "Error downloading from url %s: %s" % (url, str(e))
-        except socket.timeout, e:
-            print "Time out accessing %s: %s" % (url, str(e))
-        except socket.error, e:
-            print "Socket error when accessing %s: %s" % (url, str(e))
-        print "Sleeping %d seconds before retrying" % sleeptime
+        except six.moves.urllib.error.URLError as e:
+            print("Error downloading from url %s: %s" % (url, str(e)))
+        except socket.timeout as e:
+            print("Time out accessing %s: %s" % (url, str(e)))
+        except socket.error as e:
+            print("Socket error when accessing %s: %s" % (url, str(e)))
+        print("Sleeping %d seconds before retrying" % sleeptime)
         time.sleep(sleeptime)
         sleeptime = sleeptime * 2
         if sleeptime > max_sleeptime:
@@ -199,8 +200,8 @@ def download_config_file(url, file_name):
         f = open(file_name, 'w')
         f.write(contents)
         f.close()
-    except IOError, e:
-        print "Error writing downloaded contents to file %s: %s" % (file_name, str(e))
+    except IOError as e:
+        print("Error writing downloaded contents to file %s: %s" % (file_name, str(e)))
         raise SystemError(-1)
 
 
@@ -390,8 +391,8 @@ class BaseConfig(object):
         for action in action_list:
             if action not in self.all_actions:
                 if not quiet:
-                    print("Invalid action %s not in %s!" % (action,
-                                                            self.all_actions))
+                    print(("Invalid action %s not in %s!" % (action,
+                                                            self.all_actions)))
                 raise SystemExit(-1)
         return action_list
 
@@ -401,17 +402,17 @@ class BaseConfig(object):
             sorted_indexes = sorted(indexes)
             for i in range(len(indexes)):
                 if indexes[i] != sorted_indexes[i]:
-                    print(("Action %s comes in different order in %s\n" +
-                           "than in %s") % (action_list[i], action_list, self.all_actions))
+                    print((("Action %s comes in different order in %s\n" +
+                           "than in %s") % (action_list[i], action_list, self.all_actions)))
                     raise SystemExit(-1)
         except ValueError as e:
-            print("Invalid action found: " + str(e))
+            print(("Invalid action found: " + str(e)))
             raise SystemExit(-1)
 
     def list_actions(self):
-        print "Actions available:"
+        print("Actions available:")
         for a in self.all_actions:
-            print "    " + ("*" if a in self.default_actions else " "), a
+            print("    " + ("*" if a in self.default_actions else " "), a)
         raise SystemExit(0)
 
     def get_cfgs_from_files(self, all_config_files, options):
@@ -446,9 +447,9 @@ class BaseConfig(object):
                     all_cfg_files_and_dicts.append((cf, parse_config_file(cf)))
             except Exception:
                 if cf in options.opt_config_files:
-                    print(
+                    print((
                         "WARNING: optional config file not found %s" % cf
-                    )
+                    ))
                 else:
                     raise
         return all_cfg_files_and_dicts
diff --git a/testing/mozharness/mozharness/base/diskutils.py b/testing/mozharness/mozharness/base/diskutils.py
index 745384ff92..726f90ecc6 100644
--- a/testing/mozharness/mozharness/base/diskutils.py
+++ b/testing/mozharness/mozharness/base/diskutils.py
@@ -116,7 +116,7 @@ class DiskSize(object):
         # depending on path format (unicode or not) and python version (2 or 3)
         # we need to call GetDiskFreeSpaceExW or GetDiskFreeSpaceExA
         called_function = ctypes.windll.kernel32.GetDiskFreeSpaceExA
-        if isinstance(path, unicode) or sys.version_info >= (3,):
+        if isinstance(path, str) or sys.version_info >= (3,):
             called_function = ctypes.windll.kernel32.GetDiskFreeSpaceExW
         # we're ready for the dll call. On error it returns 0
         if called_function(path,
diff --git a/testing/mozharness/mozharness/base/log.py b/testing/mozharness/mozharness/base/log.py
index 2c18b50c33..edaa27e5c1 100755
--- a/testing/mozharness/mozharness/base/log.py
+++ b/testing/mozharness/mozharness/base/log.py
@@ -24,6 +24,7 @@ TODO:
 - log rotation config
 """
 
+from __future__ import print_function
 from datetime import datetime
 import logging
 import os
@@ -91,9 +92,9 @@ class LogMixin(object):
         """
         if not hasattr(self, 'config') or self.config.get('log_to_console', True):
             if stderr:
-                print >> sys.stderr, message
+                print(message, file=sys.stderr)
             else:
-                print message
+                print(message)
 
     def log(self, message, level=INFO, exit_code=-1):
         """ log the message passed to it according to level, exit if level == FATAL
@@ -340,7 +341,7 @@ class OutputParser(LogMixin):
             output (str | list): string or list of string to parse
         """
 
-        if isinstance(output, basestring):
+        if isinstance(output, str):
             output = [output]
         for line in output:
             if not line or line.isspace():
